/* TroiaPreview
 * version 0.4.1 date 2005-02-06
 * Copyright (C) 2003-2005 Stefan Schuermans <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

#ifndef INC_Frame
#define INC_Frame

#include "Globals.h"
#include "Pixel.h"

//initialize frame with constant color
void FrameSet( unsigned char Color );

//initialize frame with random data
void FrameRandomize( unsigned char ColorMin, unsigned char ColorMax );

//get a pixel of frame
unsigned char FrameGetPixel( tPixel3D Pix );

//set a pixel of frame
void FrameSetPixel( tPixel3D Pix, unsigned char Color );

//draw a line
void FrameLine( tPixel3D Start, unsigned char Dir, unsigned int Len, unsigned char Color );

//draw a filled rectangle
void FrameRect( tPixel3D Start, unsigned char Dir, unsigned int Width, unsigned int Height, unsigned char Color );

//draw an image
void FrameImage( tPixel3D Start, unsigned char Dir, unsigned int Width, unsigned int Height, unsigned char * pData );

//get new color for frame pixels by callback function
void FrameColorByCallback( unsigned char (*) ( tPixel3D Pixel, void * pContext ), void * pContext );

//set frame to 2D data
//p2D must point to a buffer with an entire frame in 2D format
void FrameSet2D( unsigned char * p2D );

//copy static frame into temporary frame
void FrameCopyTmp( );

//get a pixel of temporary frame
unsigned char FrameTmpGetPixel( tPixel3D Pix );

//set a pixel of temporary frame
void FrameTmpSetPixel( tPixel3D Pix, unsigned char Color );

//show pixels
//displays all pixels in the temoprary frame using OpenGL
void ShowPixels( );

#endif //#ifndef INC_Frame

